    
;===================================================================
;                   RAND.ASM
;      r a n d o m   n u m b e r   g e n e r a t o r
;
; GENERATES PSEUDO-RANDOM INTEGERS IN THE RANGE LOWER TO UPPER
; INPUT:  TWO STACK PARAMETERS - LOWER AND UPPER ENDS OF RANGE
; OUTPUT: AX-REG CONTAINS RANDOM INTEGER
; CALLING SEQUENCE:     PUSH    <LOWER END OF RANGE>
;                       PUSH    <UPPER END OF RANGE>
;                       CALL    RANDOM
;===================================================================
           .MODEL LARGE
;===================================================================
	PUBLIC  SEED
        PUBLIC  NRANDOM
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
           .FARDATA
SEED       DW      ?                   ;SEED FOR RANDOM NUMBER GEN.
MULTIPLIER DW      25173               ;MULTIPLIER AND
ADDEND     DW      13849               ;ADDEND FOR MIXED
;UPPER	   DW      9999
;LOWER	   DW      0
;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
;
           .CODE   
           ASSUME  DS:FAR_DATA
;---------------------------------------------------------------------
              
	

NRANDOM PROC    FAR PUBLIC 
		   
       
        PUSH    DS                     ;
        PUSHF                          ;SAVE FLAGS 
        
        MOV     AX,FAR_DATA            ;SET DS-REGISTER TO POINT
        MOV     DS,AX                  ;TO FAR DATA SEGMENT
        MOV     AX,SEED                ;X = SEED * MULTIPLIER mod
        MUL     MULTIPLIER          ;                       65536
        ADD     AX,ADDEND           ;SEED = (X + ADDEND) mod 65536
        MOV     SEED,AX
        MOV     CX,UPPER            ;RANGE = UPPER - LOWER + 1
        SUB     CX,LOWER
        INC     CX
        MUL     CX                  ;RANDOM = (SEED*RANGE)/65536
        ADD     DX,LOWER                ;                    + LOWER
        MOV     AX,DX
        POPF                           ;RESTORE FLAGS
        POP     DS                     ;RESTORE REGISTERS
        
        RET     4                      ;RETURN (RANDOM)
NRANDOM ENDP                           ;END NRANDOM
        END  