;===================================================================
;                   RESEED.ASM
;      r a n d o m   n u m b e r   g e n e r a t o r
;
; GENERATES PSEUDO-RANDOM INTEGERS IN THE RANGE LOWER TO UPPER
; INPUT:  TWO STACK PARAMETERS - LOWER AND UPPER ENDS OF RANGE
; OUTPUT: AX-REG CONTAINS RANDOM INTEGER
; CALLING SEQUENCE:     PUSH    <LOWER END OF RANGE>
;                       PUSH    <UPPER END OF RANGE>
;                       CALL    RANDOM
;===================================================================
           .MODEL  SMALL,BASIC
;===================================================================
	EXTERN  SEED:WORD
        PUBLIC  RESEED

	
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
           .FARDATA
;SEED       DW      ?                   ;SEED FOR RANDOM NUMBER GEN.
;MULTIPLIER DW      25173               ;MULTIPLIER AND
;ADDEND     DW      13849               ;ADDEND FOR MIXED

;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
;
           .CODE   
           ASSUME  DS:SEG SEED
;---------------------------------------------------------------------
RESEED  PROC    FAR PUBLIC USES AX CX DX DS
        MOV     AX,SEG SEED            ;SET DS-REGISTER TO POINT
        MOV     DS,AX                  ;TO FAR DATA SEGMENT
        PUSHF                          
        cmp bl,0
        jne     NOTZERO
        MOV     AH,0                   ;     SEED = LOWER HALF OF
        INT     1AH                    ;            TIME OF DAY CLOCK
	MOV SEED,DX
        jmp short endd
NOTZERO:
        MOV     SEED,5555h
endd:
        POPF                         
        RET                           
RESEED  ENDP                     
	END           